<?php

namespace App\Service;

class Layout {

  private $layoutFactory;
  private $util;

  public function __construct(\App\Factory\Layout $layoutFactory,
                              \App\Util\Util $util) {
    $this->layoutFactory = $layoutFactory;
    $this->util = $util;
  }

  public function getLayout() {
    $layoutItens     = $this->layoutFactory->getLayout();
    $layoutDefault   = array();
    $formatDSCOLUNAS = array();

    if (!empty($layoutItens)) {
      foreach ($layoutItens as $layout) {
        if ($layout['IDATIVO'] === 'S') {
          if (empty($layoutDefault)) {
              $layoutDefault[] = $this->util->layoutDefault('N');
          }
      }

      $layout['DSCOLUNAS'] = $this->util->decodeBase64($layout['DSCOLUNAS']);
      $layout['NMLAYOUT']  = $this->util->decodeBase64($layout['NMLAYOUT']);

      if (isset($layout['DSCOLUNAS'])) {
        $layout['DSCOLUNAS'] = explode(',', $layout['DSCOLUNAS']);
        $formatDSCOLUNAS[] = $layout;
      }  
    }

    foreach ($layoutItens as $itens) {
      if ($itens['IDATIVO'] === 'N') {
        if (empty($layoutDefault)) {
            $layoutDefault[] = $this->util->layoutDefault('S');
        }
      }
    }

    $layout = array_merge($layoutDefault, $formatDSCOLUNAS);
    return $layout;    
    } else { 
        $layoutDefault[] = $this->util->layoutDefault('S');
        return $layoutDefault;
    }
}

  public function saveLayout($params) {
    $params['NMLAYOUT'] = $this->util->encodeBase64($params['NMLAYOUT']);
    $layoutItens = $this->layoutFactory->getLayout();

    if (!empty($layoutItens)) {
      foreach ($layoutItens as $layout) {
        if ($layout['NMLAYOUT'] === $params['NMLAYOUT']) {
          $params['DSCOLUNAS'] = implode(',', $params['DSCOLUNAS']);
          $params['DSCOLUNAS'] = $this->util->encodeBase64($params['DSCOLUNAS']);
          $resultUpdate = $this->layoutFactory->updateLayout($params);

          if ($resultUpdate > 0) {
            return 'Layout atualizado com sucesso.';
          } else {
            throw new \Exception('Ocorreu um erro ao atualizar o layout.');
          }
        }

        $collumns = implode(',', $params['DSCOLUNAS']);
        $encodeCollumns = $this->util->encodeBase64($collumns);
        $decodeLayout =  $this->util->decodeBase64($layout['NMLAYOUT']);
        if ($encodeCollumns === $layout['DSCOLUNAS']) {
          throw new \Exception('Já existe um layout salvo com a configuração selecionada: Layout ' . strtoupper($decodeLayout) . '.');
        }

          if ($layout['IDATIVO'] === 'S') {
          $layout['IDATIVO'] = 'N';
          $this->layoutFactory->updateLayout($layout);
          }
        }
    }

    $params['DSCOLUNAS'] = implode(',', $params['DSCOLUNAS']);
    $params['DSCOLUNAS'] = $this->util->encodeBase64($params['DSCOLUNAS']);
    $layout = $this->layoutFactory->saveLayout($params);

    if ($layout  > 0) {
      return 'Layout salvo com sucesso.';
    } else {
      throw new \Exception('Ocorreu um erro ao salvar o layout.');
    }
  }

  public function updateLayout($params) {
    $layoutItens = $this->layoutFactory->getLayout();

    foreach ($layoutItens as $layout) {
        if ($layout['IDATIVO'] === 'S') {
            $layout['IDATIVO'] = 'N';
            $this->layoutFactory->updateLayout($layout);
        }
      }

      if ($params['NMLAYOUT'] !== 'Padrão') {
          $params['DSCOLUNAS'] = null;
          $params['NMLAYOUT'] = $this->util->encodeBase64($params['NMLAYOUT']);
          $this->layoutFactory->updateLayout($params);
      }
  }

  public function deleteLayout($params) {
    $params['NMLAYOUT'] = $this->util->encodeBase64($params['NMLAYOUT']);
    $layout = $this->layoutFactory->deleteLayout($params);

    if ($layout  > 0) {
      return 'Layout excluído com sucesso.';
    } else {
      throw new \Exception('Ocorreu um erro ao excluir o layout.');
    }
  }
}