import { FormatHandle } from '../interfaces/FormatHandle';
import { StatusOptions } from '../interfaces/StatusOptions';

class FormatCommandStatus implements FormatHandle {
  public format(value: string, options: StatusOptions): string {
    const commandStatusMap: { [key: string]: string } = {
      1: options.isSincMSDE === 'N' ? '-' : 'em produção',
      2: options.isSincMSDE === 'N' ? '-' : 'em produção',
      3: options.isSincMSDE === 'N' ? '-' : 'em produção',
      4: options.isSincMSDE === 'N' || options.isSincMSDE === 'S' ? 'cancelado' : '',
      5: options.isSincMSDE === 'N' ? '-' : 'expedido',
      6: options.isSincMSDE === 'N' ? '-' : 'não pago',
      X: options.isSincMSDE === 'N' ? '-' : 'finalizado',
      P: options.isSincMSDE === 'N' ? '-' : 'impresso',
      A: options.isSincMSDE === 'N' ? '-' : 'agendado',
      N: options.isSincMSDE === 'N' ? '-' : 'não sincronizado',
    };
    return commandStatusMap[value];
  }
}

export default new FormatCommandStatus();
